<template>
    <div class="format-switcher__wrapper">
        <div class="format-switcher"
             ref="app_switcher">
            <div class="switch"
                 :style="{
                    width: `${switchWidth}px`,
                    left: `${switchLeft}px`
                 }"
                 ref="switch">
            </div>
            <button v-for="format in formats"
                    ref="buttons"
                    :class="{'active': get('format') === format}"
                    @click="changeFormat(format)"
                    :key="format">
                {{ format }}
            </button>
        </div>
    </div>
</template>

<script>
    import { mapGetters } from 'vuex'

    export default {
        name: "FormatSwitcher",
        props: {
            formats: {
                type: Array
            }
        },
        data() {
            return {
                width: 0,
                switch: {
                    index: 0,
                    width: 0,
                    left: 0
                },
            }
        },
        computed: {
            ...mapGetters([
                'get'
            ]),
            switchWidth() {
                return this.switch.width;
            },
            switchLeft() {
                return this.switch.left;
            }
        },
        mounted() {
            this.defineSwitchParams(this.get('format'));
        },
        methods: {
            changeFormat(format) {
                this.$store.commit('set', {key: 'format', value: format});
                this.defineSwitchParams(format);
            },
            defineSwitchParams(format) {
                this.switch.index = this.formats.indexOf(format);
                this.switch.width = this.$refs.buttons[this.switch.index].clientWidth;
                this.switch.left = this.$refs.buttons[this.switch.index].offsetLeft;
            }
        }
    }
</script>

<style scoped lang="scss">
    $switcher-height: 20px;

    .format-switcher {
        position: relative;
        border-radius: 15px;
        display: inline-block;

        &__wrapper {
            padding: 2px;
            font-size: 14px;
            display: inline-block;
            border-radius: 15px;
            box-shadow: 0 0 3px 1px silver;
            line-height: 1;
            background-color: #969494;
        }

        .switch {
            background-color: darkorange;
            height: $switcher-height;
            border-radius: 15px;
            position: absolute;
            transition: .3s;
            z-index: 0;
        }

        button {
            height: $switcher-height;
            background-color: transparent;
            position: relative;
            color: #ffffffa3;
            border: none;
            padding: 0 .7rem;
            z-index: 1;

            &:focus {
                outline: none;
            }

            &.active {
                color: white;
            }
        }
    }
</style>